﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class UIHideshow : MonoBehaviour
{
    void Start()
    {
        GetComponent<CanvasGroup>().alpha = 0;
    }
    
    public void EnterUIShow()
    {
        GetComponent<CanvasGroup>().alpha = 1;
        GameObject.Find("Main Camera").GetComponent<CameraOrbit>().canScroll = false;
    }

    public void ExitUIHide()
    {
        GetComponent<CanvasGroup>().alpha = 0;
        GameObject.Find("Main Camera").GetComponent<CameraOrbit>().canScroll = true;
        foreach (var dd in GameObject.Find("LeftUI").GetComponentsInChildren<Dropdown>())
            dd.Hide();
    }
}